import { type IAnimatable, type IAnimation, type IOptionLoader, type RangeValue, type RecursivePartial, RotateDirection, type RotateDirectionAlt } from "tsparticles-engine";
import { GradientAngleAnimation } from "./GradientAngleAnimation";
import type { IGradientAngle } from "../Interfaces/Gradients";
export declare class GradientAngle implements IGradientAngle, IAnimatable<IAnimation>, IOptionLoader<IGradientAngle & IAnimatable<IAnimation>> {
    animation: GradientAngleAnimation;
    direction: RotateDirection | keyof typeof RotateDirection | RotateDirectionAlt;
    value: RangeValue;
    constructor();
    load(data?: RecursivePartial<IGradientAngle & IAnimatable<IAnimation>>): void;
}
