(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tsparticles-engine", "./GradientColorOpacity"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AnimatableGradientColor = void 0;
    const tsparticles_engine_1 = require("tsparticles-engine");
    const GradientColorOpacity_1 = require("./GradientColorOpacity");
    class AnimatableGradientColor {
        constructor() {
            this.stop = 0;
            this.value = new tsparticles_engine_1.AnimatableColor();
        }
        load(data) {
            if (!data) {
                return;
            }
            if (data.stop !== undefined) {
                this.stop = data.stop;
            }
            this.value = tsparticles_engine_1.AnimatableColor.create(this.value, data.value);
            if (data.opacity !== undefined) {
                this.opacity = new GradientColorOpacity_1.GradientColorOpacity();
                if ((0, tsparticles_engine_1.isNumber)(data.opacity)) {
                    this.opacity.value = data.opacity;
                }
                else {
                    this.opacity.load(data.opacity);
                }
            }
        }
    }
    exports.AnimatableGradientColor = AnimatableGradientColor;
});
