(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./GradientUpdater"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadGradientUpdater = void 0;
    const GradientUpdater_1 = require("./GradientUpdater");
    async function loadGradientUpdater(engine, refresh = true) {
        await engine.addParticleUpdater("gradient", () => new GradientUpdater_1.GradientUpdater(), refresh);
    }
    exports.loadGradientUpdater = loadGradientUpdater;
});
